#include <windows.h>
#include <stdio.h>


#define ALLOCATE_NUM (10000)


int main(int argc, char* argv[]) {

	UINT i, j;
	char* p [ALLOCATE_NUM];
	DWORD dwStart, dwEnd;
	DWORD dwSize = 16; // Initial value
	HANDLE hHeap = GetProcessHeap ();
	
	for ( i=0; i < 10; i ++ ) {

		//
		// Stand-by
		//

		Sleep ( 3 * 1000 );

		//
		// Allocate 1000 memory blocks
		//
		
		dwStart = GetTickCount ();

		for ( j=0; j< ALLOCATE_NUM; j++) {

			p[j] = (char*) HeapAlloc ( hHeap, 0, dwSize );
			if ( !p[j] ) {
				printf ("ERROR!!\n");
				return 1;
			}

			FillMemory ( p[j], dwSize, 'x' );
			
		}

		dwEnd = GetTickCount ();

		//
		// Print the result
		//
		
		printf ("%8u [byte] %8u [ms]\n", dwSize, dwEnd - dwStart );

		//
		// Free all the memory blocks
		//
		
		for ( j=0; j < ALLOCATE_NUM; j++ ) {

			HeapFree ( hHeap, 0, p[j] );

		}
		
		//
		// Change an allocate size
		//

		dwSize *= 2;

	}

		
	
	return 0;

}
